#!/usr/bin/perl

#use strict;
#use warnings;
use File::Copy;
use File::Path;
use File::Basename;
use IO::Socket::INET;

require 'common.pm';

my $logfile = @ARGV > 0 ? $ARGV[0] : die "error file name";
chomp( $logfile );

print "source log: $logfile\n";

my $sourcename = undef;
my $fyear = undef;
my $fmonth = undef;
my $fday = undef;
# log20150323.csv
if( basename($logfile) =~ /^(\w+)(\d{4})(\d{2})(\d{2})\.csv$/ )
{
    $sourcename = $1;
    $fyear = $2;
    $fmonth = $3;
    $fday = $4;
}
else
{
    die "[!]incorrect log path name: $logfile\n";
}

# отнимаем один день от даты названия лога
#my $dt = DateTime->new(
#    year => $fyear,
#    month => $fmonth,
#    day => $fday,
#);
#$dt->add( days => -1 );
#$fyear = $dt->year;
#$fmonth = sprintf("%02d", $dt->month);
#$fday = sprintf("%02d", $dt->day);

# текущий таймштамп
#my $now_time = DateTime->now(time_zone=>'local');
#my $now_timestamp = sprintf("%02d.%02d.%04d %02d:%02d:%02d", $now_time->day,$now_time->month,$now_time->year, $now_time->hour,$now_time->minute,$now_time->second);
my ($zsec,$zmin,$zhour,$zday,$zmon,$zyear,$zwday,$zyday,$zisdst)=localtime(time);
my $now_timestamp = sprintf("%02d.%02d.%04d %02d:%02d:%02d", $zday,$zmon+1,$zyear+1900, $zhour,$zmin,$zsec);

my $source_id = $SOURCE_ID{$sourcename};

print "source: $sourcename (id: $source_id)\ndate: $fday.$fmonth.$fyear\n";

open( FILE, "$logfile" ) or die "[!]can't open file '$logfile': $!\n";

my %DATA;

my $cnt_lines_total = 0;
my $cnt_lines_error = 0;

LINE: while( <FILE> )
{
    ++$cnt_lines_total;

    #      16803 ,    23     ,    03     ,    2015   ,    00     ,    12     ,    20     ,    124    ,    254247 ,    397197 ,   2     ,   MC240 ,   3     ,    4.0pri ,    1.0pri ,   0     ,   1     ,   55 ^M
    if ( /^\d+\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*\d+\s*,\s*\w+\s*,\s*\d+\s*,\s*(\S+)\s*,\s*(\S+)\s*,\s*\d+\s*,\s*\d+\s*,\s*\d+\s*$/ ) 
    {
        my ( $dd, $mm, $yy, $h, $m, $s, $amount, $from_num, $to_num, $portA, $portB ) = ( $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11 ); 

	#print "$dd.$mm.$yy $h:$m:$s ($amount) [$from_num] -> [$to_num] [$portA][$portB]\n";

#	my $from_num = undef;
#	my $to_num = undef;

#	my $from_num_e164 = undef;
#	my $to_num_e164 = undef;
	
	my $timestamp4log = "$dd.$mm.$yy $h:$m:$s";
	my $duration4log = $amount;
	
	my $from_num_e164 = num_to_164( $from_num, $timestamp4log, $duration4log, "from", $_ );
	my $to_num_e164 = num_to_164( $to_num, $timestamp4log, $duration4log, "to", $_ );

	#print "$dir | $num6 | $yy.$mm.$dd $h:$m:$s - $yy2.$mm2.$dd2 $h2:$m2:$s2 | $to_num | $from_num\n";

	my $port1 = $portA;
	my $port2 = $portB;
	my $type = 0;
	
	my $value = "$dd.$mm.$yy $h:$m:$s\t$amount\t$from_num\t$from_num_e164\t$to_num\t$to_num_e164\t$port1\t$port2\t$type\n";
	
	my $key = $yy."_".$mm."_".$dd."_".$h;
	$DATA{$key} .= $value;
    }
    else
    {
    	# убираем перевод каретки и перевод строки на конце, если есть
	$badline = $_;
	$badline =~ s/[\r\n]*$//;

	++$cnt_lines_error;

	warn "unrecognized string: [$badline]\n";
	
	open( FILE3, ">>bglogconverter.run.error.log" ) or die "can't create file 'bglogconverter.run.error.log': $!\n";
	print FILE3 "$now_timestamp [$badline]\n";
	close( FILE3);
    }
}

close( FILE );

print "OK. lines total: $cnt_lines_total, lines error: $cnt_lines_error\n";

# make dest files
my $path = $DEST_PATH."/".$sourcename."/".$fyear."/".$fmonth;
mkpath($path);

for ($h=0; $h<=23; $h++)
{
    $h = sprintf("%02d", $h);
    $file = $path."/".$fday."_".$h;
    #print "delete $file, $file.zip\n";
    unlink($file);
    unlink($file.".zip");
}

foreach my $key ( keys %DATA )
{
    my ( $YY, $MM, $DD, $HH ) = split( /_/, $key );
    
#    if( ($fyear != $YY) or ($fmonht != $MM) or ($fday != $DD) )
#    {
#    	warn "[!]data record: $DD.$MM.$YY filename: $fday.$fmonth.$fyear\n";
#	next;
#    }
    
    my $file = $path."/".$fday."_".$HH;  # only HH use from logdata

    # print data into file
    open( FILE, ">>".$file ) or die "can't create file '$file': $!\n";
    print FILE $DATA{$key};
    close( FILE );
}

for ($h=0; $h<=23; $h++)
{
    $h = sprintf("%02d", $h);
    $file = $path."/".$fday."_".$h;
    print "compress $file\n";

    # make archive
    chdir $path;
    #my $err = `$ZIP_ADD ${dd}_${hh}.zip ${dd}_${hh}`;
    #system("$ZIP_ADD ${fday}_${HH}.zip ${fday}_${HH}");
    system("$ZIP_ADD ${fday}_${h}.zip ${fday}_${h}");
    #chdir $base_path; 
}



for ($h=1; $h<=24; $h++)
{    
    print "adding log $fyear-$fmonth-$fday-$h-$source_id to loader...\n"; 
    #system( "/home/BGBillingServer/data_loader.sh -eload=$year-$month-$day-$hour-3");
    
    # create a connecting socket
    my $socket = new IO::Socket::INET (
	PeerHost => $DATALOADER_HOST,
	PeerPort => $DATALOADER_PORT,
	Proto => "tcp",
    );
    die "cannot connect to the server $!\n" unless $socket;
    #print "connected to the server\n";
    my $req = "load=$fyear-$fmonth-$fday-$h-$source_id";
    $socket->send($req);
    $socket->close();
}


sub num_to_164
{
    my $num = shift;
    my $timestamp4log = shift;
    my $duration4log = shift;
    my $napravl = shift;
    my $originalline = shift;

    $originalline =~ s/\s+$//;
    #$originalline =~ s/\s/_/g;

    # нормальный номер: 7 + 10 цифр, сразу уходим

    if( $num =~ /^7(\d{10})$/ )
    {
	return $num;
    }    

    # почти нормальный номер: если 8 + 10 цифр - заменяем на 7, сразу уходим
    
    if( $num =~ /^8(\d{10})$/ )
    {
	$num = "7$1";
	return $num;
    }

    # все [шестизначные] номера докрутить до 10 знаков (т.е. добавить код города Тобольска (3456) HD#5569
    if( $num =~ /^(\d{6})$/ )
    {
	$num = "73456$1";
	return $num;
    }

    # если 10 цифр - добавляем 7, сразу уходим
    if( $num =~ /^(\d{10})$/ )
    {
	$num = "7$1";
	return $num;
    }
    
    # Семизначные номера вида 6398ХХХ необходимо так же дополнять до 11 цифр, т.е. добавлять 7345. Эти номера летят с АТС подключенной к МС-240 транзитом.
    if( $num =~ /^6398(\d{3})$/ )
    {
	$num = "73456398$1";
	return $num;
    }
    

    # далее применяем правила

    # нормальные TO-номера: сразу считать валидными:
    #1.) двузначные: 0+1цифра
    #2.) трёхзначные: 1+2цифры
#    if($napravl eq 'to')
#    {
#        if( $num =~ /^0(\d)$/ )
#        {
#	    return $num;
#	}
#	if( $num =~ /^1(\d\d)$/ )
#	{
#	    return $num;
#	}
#    }

    # нормальный международный: отрезаем 810, считаем что валидный, сразу уходим
#    if( $num =~ /^810(\d+)$/ )
#    {
#	$num = "$1";
#	return $num;
#    }


    # если с 8 начинается (но не 810 - мы выше уже ушли) + дальше любой длины больше 10 , то заменяем на 7, отрезаем до 10, уходим

#    if( $num =~ /^8(\d{10})\d*$/ )
#    {
#	$num = "7$1";
#	return $num;
#    }
    
    # если на 7 начинается + дальше любой длины больше 10, отрезаем только 10 цифр, сразу уходим
    
#    if( $num =~ /^7(\d{10})\d*$/ )
#    {
#    	$num = "7$1";
#	return $num;
#    }    

    # не получилось ничего сделать с номером
    {
        open( FILE2, ">>bglogconverter.num.error.log" ) or die "can't create file 'bglogconverter.num.error.log': $!\n";
        print FILE2 "$timestamp4log\t$num\t$duration4log\t$napravl\t[$originalline]\n";
	close( FILE2 );
	# зануляем, если не получилось конвертировать
	#if($napravl eq 'to')
	#{
	#    # для TO зануляем
	#    $num = "";
	#}
	#else
	#{
	#    # для FROM пишем туда не(до)преобразованный	    
	#}	
    }
    return $num;
}
